/**Modela el estanque del final, con una valvula como
 * entrada y la bomba de salida como salida. 
 *
 * 
 */
public class EstanqueFinal extends Estanque{
    private Valvula entrada;
    private Bomba salida;
    private int larg;
    private int altura_estanque;
    
    public EstanqueFinal(Valvula entrad, Bomba salid,  int anch,int lar, int alt,int posx, int posy)
    {
         super(lar,anch,alt,posx, posy, posy,posy+entrad.get_alto());
         entrada=entrad;
         salida=salid;
         larg=lar;
         altura_estanque=alt;
    }
    
    public void actualiza_altura()
    {
       altura=CantAgua/area;
       if(altura>(altura_estanque-(int) (larg*0.707/2))){
           altuT=(int) (altura-altura_estanque+(int) (larg*0.707/2));
       }
       else{
           altuT=0;
       }
       super.repaint();
       }
    
    public void actualiza_CAgua(double time)
    {
       double caudal_entrada= entrada.get_caudal();
       double caudal_salida= salida.get_caudal();
       double nueva_agua= (caudal_entrada-caudal_salida)*time;//cantidad de agua que entra al estanque
       if(((CantAgua+nueva_agua)>0)&&((CantAgua+nueva_agua)<VolumenE))//restringe la altura del liquido entre 0 y 500
           CantAgua=CantAgua+nueva_agua;
       else if((CantAgua+nueva_agua)<=0)
           CantAgua=0;
       else if((CantAgua+nueva_agua)>=VolumenE)
           CantAgua=VolumenE;
       //super.repaint();
       }
    
    public double get_caudal()
    {
        return entrada.get_caudal();
    }
}
