/** Crea la interfaz gráfica del estanque las bombas y la valvula.
 * 
 * 
 */
import java.awt.geom.*;
import java.awt.*;
import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Graphics2D;


public class EstanqueView extends JPanel{
    private Estanque.ViewAgua aeView;
    private Estanque.ViewEstanque eView;
    private Estanque.ViewAgua aeView1;
    private Estanque.ViewEstanque eView1;
    private BombaEntrada.ViewAgua abView;
    private BombaEntrada.ViewBomba bView;
    private BombaSalida.ViewAgua abView1;
    private BombaSalida.ViewBomba bView1;
    private Valvula.ViewValvula vView;
    private Valvula.ViewAgua avView;  
    
    public EstanqueView(BombaEntrada.ViewAgua abView,BombaEntrada.ViewBomba bView,BombaSalida.ViewAgua abView1,BombaSalida.ViewBomba bView1){
      
      this.abView = abView;
      this.bView = bView;
      this.abView1 = abView1;
      this.bView1 = bView1;
      
      }
   
    public void set_Estanques(Estanque.ViewAgua aeView,Estanque.ViewEstanque eView,Estanque.ViewAgua aeView1,Estanque.ViewEstanque eView1){
        this.aeView = aeView;
        this.eView=eView;
        this.aeView1 = aeView1;
        this.eView1=eView1;
        }
    
    public void set_Valvulas(Valvula.ViewValvula vView,Valvula.ViewAgua avView){
        
        this.avView= avView;
        this.vView= vView;
    }
   public void paintComponent(Graphics g) {
      super.paintComponent(g);  // it paints the background
      Graphics2D g2d = (Graphics2D) g;
      g2d.transform(SPACE_TRANSFORM);  // after this transformation
                  // the panel space can be used in [m] and not pixels.
      
      //dibujo Bomba1
      g2d.setStroke(new BasicStroke(1f));
      bView.draw(g2d); // draw bomba 1
      g2d.setStroke(new BasicStroke(1f));
      abView.draw(g2d);// draw agua*/
      //dibujo estanque 1
      g2d.setStroke(new BasicStroke(1f));
      eView.draw(g2d); // draw estanque1
      g2d.setStroke(new BasicStroke(1f));
      aeView.draw(g2d);// draw agua*/
      //dibujo estanque 2
      g2d.setStroke(new BasicStroke(1f));
      eView1.draw(g2d); // draw estanque
      g2d.setStroke(new BasicStroke(1f));
      aeView1.draw(g2d);// draw agua*/
      //dibujo bomba 2
      g2d.setStroke(new BasicStroke(1f));
      bView1.draw(g2d); // draw bomba 2
      g2d.setStroke(new BasicStroke(1f));
      abView1.draw(g2d);// draw agua*/
      //dibujo valvula1
      g2d.setStroke(new BasicStroke(1f));
      vView.draw(g2d);// draw valvula
      g2d.setStroke(new BasicStroke(1f));
      //avView.draw(g2d);// draw agua*/
     }
   
   // BEGIN declarations to use metric coordinate system (not pixels)
// Do not worry for this code. It allows us use meter and not pixels 
// as distance metric. It also changes the axes so the origen is on the bottom left.
   public static int WIDTH = 700;  // caja escala width in pixels
   public static int HEIGHT = 1000; // caja escala height in pixels
   public static int X_ORIGEN = (int)(WIDTH*0.1); // Caja escala origen (x,y) [m] will be on
   public static int Y_ORIGEN = (int)(HEIGHT*0.3); // (X_ORIGEN,Y_ORIGEN) of the panel space.
   public static AffineTransform SPACE_TRANSFORM;  // transforms (x,y) [m] in (X,Y) [pixels] of panel.
   public static Line2D.Double X_AXIS;  // lines to draw my world axes (singular axis, plural axes).
   public static Line2D.Double Y_AXIS;
   private static double AXES_SCALE = HEIGHT/300;  // 1 [cm] equals AXES_SCALE [pixels]. 100 para tener 1 [m] en el 90% de HEIGHT
   
   static {
       SPACE_TRANSFORM = AffineTransform.getTranslateInstance(X_ORIGEN, Y_ORIGEN);
       SPACE_TRANSFORM.scale(AXES_SCALE,-AXES_SCALE);  // it also inverts direction of y-coordinate 
       X_AXIS = new Line2D.Double(-0.1, 0, 2.5, 0);  // each axis length is 2 [m] from origen.
       Y_AXIS = new Line2D.Double(0, -0.1, 0, 2.0);       
   }
// END declarations to use metric coordinate system (not pixels)
}
