
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;


public class PanelBotones {
    JPanel panelPrincipal;
    JPanel panelPrimario;
    JPanel panelBoton;
    JPanel panelSecundario;
    JPanel panelTerciario;
    JButton botonInicio;
    JButton botonPausa;
    JRadioButton BotonManual;
    JRadioButton BotonAuto;
    JPanel panelRboton;
    ButtonGroup gRBotones;
    JPanel panelAlturas;
    Estanque Einicial;
    Estanque Efinal;
    Estanque Eintermedio1;
    Estanque Eintermedio2;
    int numE;
    public JLabel altura1=new JLabel("0.0",JLabel.CENTER);
    public JLabel altura2=new JLabel("0.0",JLabel.CENTER);
    public JLabel altura3=new JLabel("0.0",JLabel.CENTER);
    public JLabel altura4=new JLabel("0.0",JLabel.CENTER);
    public JLabel altura5=new JLabel("0.0",JLabel.CENTER);
    public JLabel nombre1=new JLabel("Altura 1",JLabel.CENTER);
    public JLabel nombre2=new JLabel("Altura 2",JLabel.CENTER);
    public JLabel nombre3=new JLabel("Altura 3",JLabel.CENTER);
    public JLabel nombre4=new JLabel("Altura 4",JLabel.CENTER);
    public JLabel nombre5=new JLabel("Altura 5",JLabel.CENTER);
    int EstadoPausa=0;
    int EstadoInicio=0;
    Motor_Bombas Motor;
    
    public PanelBotones(Estanque ini, Estanque fin, int nEstanques){
      Einicial= ini;
      Efinal= fin;
      numE=nEstanques;
        //panel principal
      panelPrincipal= new JPanel();
      panelPrincipal.setLayout(new GridLayout(3,1));
      panelPrincipal.setBorder(BorderFactory.createLineBorder(Color.black));
      
       //panel boton inicio pausa
      panelPrimario= new JPanel();
      panelPrimario.setLayout(new GridLayout(2,2));
      panelPrimario.setBorder(BorderFactory.createLineBorder(Color.red));
      panelPrimario.add(new JLabel("Inicio y Pausa de la bomba",JLabel.CENTER));
      panelBoton= new JPanel();
      panelBoton.setLayout(new FlowLayout());
      botonInicio= new JButton("Iniciar");
      panelBoton.add(botonInicio);
      botonPausa= new JButton("Pausa");
      panelBoton.add(botonPausa);
      panelPrimario.add(panelBoton);
      panelPrincipal.add(panelPrimario);
        
      //Panel seleccion tipo de controlador
      panelSecundario= new JPanel();
      panelSecundario.setLayout(new GridLayout(2,1));
      panelSecundario.setBorder(BorderFactory.createLineBorder(Color.red));
      panelSecundario.add(new JLabel("Tipo de Controlador",JLabel.CENTER));
      BotonManual=new JRadioButton("Manual",true);
      BotonAuto=new JRadioButton("PID",false);
      panelRboton= new JPanel();
      panelRboton.setLayout(new FlowLayout());
      panelRboton.add(BotonManual);
      panelRboton.add(BotonAuto);
      panelSecundario.add(panelRboton);
      panelPrincipal.add(panelSecundario);
      gRBotones = new ButtonGroup();
      gRBotones.add(BotonManual);
      gRBotones.add(BotonAuto);
      
      //panel de alturas
      panelTerciario= new JPanel();
      panelTerciario.setLayout(new GridLayout(2,1));
      panelTerciario.setBorder(BorderFactory.createLineBorder(Color.red));
      panelTerciario.add(new JLabel("Alturas",JLabel.CENTER));
      panelAlturas= new JPanel();
      panelAlturas.setLayout(new GridLayout(numE,1));
      for(int i=0; i<numE;i++){
          if(i==0){
            panelAlturas.add(nombre1);
            panelAlturas.add(altura1);
            altura1.setBorder (BorderFactory.createLineBorder(Color.red, 1));
          }
          else if(i==1){
            panelAlturas.add(nombre2);
            panelAlturas.add(altura2);
            altura2.setBorder (BorderFactory.createLineBorder(Color.red, 1));
          }
          else if(i==2){
            panelAlturas.add(nombre3);
            panelAlturas.add(altura3);
            altura3.setBorder (BorderFactory.createLineBorder(Color.red, 1));
          }
          else if(i==3){
            panelAlturas.add(nombre4);
            panelAlturas.add(altura4);
            altura4.setBorder (BorderFactory.createLineBorder(Color.red, 1));
          }
          else if(i==4){
            panelAlturas.add(nombre5);
            panelAlturas.add(altura5);
            altura5.setBorder (BorderFactory.createLineBorder(Color.red, 1));
          }
      }
      
      panelTerciario.add(panelAlturas);
      panelPrincipal.add(panelTerciario);
      
      //listener de los botones
      botonInicio.addActionListener( new ActionListener (){
         public void actionPerformed(ActionEvent event) {
          if(BotonManual.isSelected()==true){
              Motor.startManual();
          }
          if(BotonAuto.isSelected()==true){
              Motor.startPid();
          }
            
         };
      });
      botonPausa.addActionListener( new ActionListener (){
         public void actionPerformed(ActionEvent event) {
          Motor.pause();
            
         };
      });
      
      
      //////////////////////////////////////////
    }
    
    public JPanel getPanel(){

        return panelPrincipal;
    }
    
    public void set_label(){
            
            altura1.setText(String.valueOf((double)Math.round(Einicial.get_altura() * 100d) / 100d));
            altura2.setText(String.valueOf((double)Math.round(Efinal.get_altura() * 100d) / 100d));
           
                        
    }
    
    public void set_Motor(Motor_Bombas m){
        Motor=m;
    }
    
    public void set_Rboton(Editar_valor V,Editar_valor A,Controlador pid){
        //validacion Rboton.
      if(BotonManual.isSelected()==true){
         A.blok_seccion();//bloquea la seccion
         V.Dblok_seccion();//desbloquea la seccion
         pid.blok_seccion();
         Motor.startManual();
      }
      
      else if(BotonAuto.isSelected()==true){
         V.blok_seccion();
         A.Dblok_seccion();
         pid.Dblok_seccion();
         Motor.startPid();
      }
    }
}
