/**Crea los Sliders que se ven en a ventana principal
 * utilizados para dar los valores al voltaje de
 * las bombas, altura de los estanques y constantes 
 * del controlador
 * 
 */
import javax.swing.JSlider;
import javax.swing.*;


public class Slider {
    
    JSlider slider;
    double valor;
    
    public Slider(int menor,int mayor, int inicio){
     //creacion del slider
      slider = new JSlider(JSlider.HORIZONTAL,menor,mayor,inicio);//(posicion horizontal,comienza,termina,donde comienza el programa)
      slider.setInverted(false);//se invierte el relleno
      slider.setMajorTickSpacing(mayor);//de cuanto en cuanto los numeros del slider
      slider.setMinorTickSpacing(mayor);//de cuanto en cuenato las rayitas
      java.util.Hashtable<Integer,JLabel> labelTable = new java.util.Hashtable<Integer,JLabel>();
      double VMayor= mayor/10;
      labelTable.put(new Integer(mayor), new JLabel(String.valueOf(VMayor)));
      labelTable.put(new Integer(0), new JLabel("0.0"));
      slider.setLabelTable( labelTable );
      //slider.setPaintTicks(true);//(las rayitas que marcan los numeros)
      
      slider.setPaintLabels(true);//si se ven los numeros
      slider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                valor=slider.getValue();
               // System.out.println(valor);
            }
        });//agrega un escuchador
}
    public JSlider getSlider(){
        return slider;
    }
    
    public double getValor(){
        
        return valor/10;
    }
    
    public void set_valor(int i){
        slider.setValue(i);
    }
    
    public void blokear_slider(){
    
        slider.setEnabled(false);
    }
    
    public void desblokear_slider(){
    
        slider.setEnabled(true);
    }
}
